# -*- coding: utf-8 -*-
from setuphelpers import *

uninstallkey = []
softname = 'Microsoft Office Professionnel Plus 2016'
pathosppvbs32 = makepath(programfiles32,'Microsoft Office','Office16','OSPP.VBS')
pathosppvbs64 = makepath(programfiles64,'Microsoft Office','Office16','OSPP.VBS')

def install():

    def killsoft():
      for soft in ('WINWORD.EXE','POWERPNT.EXE','EXCEL.exe','MSPUB.EXE','MSACCESS.EXE','INFOPATH.EXE','lync.exe','ONENOTE.EXE','OUTLOOK.EXE','ONENOTEM.EXE','MSOSYNC.EXE','GROOVE.EXE'):
        if isrunning(soft):
           print ("closing %s" % soft)
           killalltasks(soft)


    if not installed_softwares(softname):
        print('Installing Office 2016')
        cmd = '"setup.exe" /adminfile "silent.msp"'
    else:
        print('Repair and add component to ' + softname)
        cmd = 'msiexec.exe /p silent.msp'

    killsoft()
    run(cmd,timeout=1200,accept_returncodes=[1641,3010,0])
    if not installed_softwares(softname):
        error(' %s has been installed but the uninstall key can not be found' % softname)

    #Activation
    if isfile(pathosppvbs32):
        pathosppvbs = pathosppvbs32
    if isfile(pathosppvbs64):
        pathosppvbs = pathosppvbs64

    if 'ERROR' in run('cscript "%s" /dstatus'  % pathosppvbs):
        print("Running activation of " + softname)
        resultact = run('cscript "%s" /act' % pathosppvbs)

        if 'ERROR' in run('cscript "%s" /dstatus'  % pathosppvbs):
            error('Activation did not work : ' + resultact)
    else:
        print('Already activated Product')


def uninstall():
    open(makepath(programfiles32,'silent.xml'), "w" ).write(silentxml)
    run('"%s" /uninstall ProPlus /config "%s"' % (makepath(programfiles32,'Common Files','microsoft shared','OFFICE16','Office Setup Controller','Setup.exe'),makepath(programfiles32,'silent.xml')),timeout=1200)
    remove_file(makepath(programfiles32,'silent.xml'))

silentxml = r"""<Configuration Product="ProPlus">
<Display Level="none" CompletionNotice="no" SuppressModal="yes" AcceptEula="yes" />
   <Setting Id="SETUP_REBOOT" Value="NEVER" />
</Configuration>
"""